package com.ibm.sysmgt.raidmgr.cim.provider.instance;

import com.ibm.sysmgt.raidmgr.util.*;
import com.ibm.sysmgt.raidmgr.dataproc.*;
import com.ibm.sysmgt.raidmgr.dataproc.config.*;
import com.ibm.sysmgt.raidmgr.cim.provider.*;

import com.ibm.sysmgt.cim.cimfac.CIMOMHandle;

import com.sun.wbem.cim.*;
import com.sun.wbem.provider.CIMProvider;
import com.sun.wbem.provider20.Authorizable;
import com.sun.wbem.provider20.InstanceProvider;
import com.sun.wbem.query.SelectExp;

import java.util.*;
import java.io.*;
import java.rmi.RemoteException;

/** This class provides a base instance provider class for the various instance providers.
  * This class takes care of the common instance provider methods.
  */
public abstract class RAIDInstanceProviderBase extends RAIDProvider implements InstanceProvider
{
   protected static PrintWriter instanceLog = setupLog("RAIDInstanceProvider.log");

   public RAIDInstanceProviderBase(String logHeader)
   {
      super(logHeader);
   }

   /** Satisfies the InstanceProvider interface */
   public CIMObjectPath createInstance(CIMObjectPath op, CIMInstance ci) throws CIMException
   {
      instanceLog.println(logHeader + "createInstance()");
      throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
   }

   /** Satisfies the InstanceProvider interface */
   public void deleteInstance(CIMObjectPath op) throws CIMException
   {
      instanceLog.println(logHeader + "deleteInstance()");
      throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
   }

   /** Satisfies the InstanceProvider interface
     * Enumerates only the names of instances of the class specified by op
     */
   public abstract Vector enumInstances(CIMObjectPath op, boolean deep, CIMClass cc) throws CIMException;

   /** Satisfies the InstanceProvider interface
     * Enumerates the instances of the class specified by op
     */
   public abstract Vector enumInstances(CIMObjectPath op, boolean deep, CIMClass cc, boolean localOnly) throws CIMException;

   /** Satisfies the InstanceProvider interface */
   public Vector execQuery(CIMObjectPath op, String query, int ql, CIMClass cc) throws CIMException
   {
      instanceLog.println(logHeader + "execQuery()");
      throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
   }

   /** Satisfies the InstanceProvider interface */
   public abstract CIMInstance getInstance(CIMObjectPath op, CIMClass cc, boolean localOnly) throws CIMException;

   /** Satisfies the InstanceProvider interface */
   public void setInstance(CIMObjectPath op, CIMInstance ci) throws CIMException
   {
      instanceLog.println(logHeader + "setInstance()");
      throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
   }
}
